diff -uNrd ircd-hybrid-6.0/src/dline_conf.c ircd-pi1.0a/src/dline_conf.c
--- ircd-hybrid-6.0/src/dline_conf.c	Fri Dec 10 23:11:34 1999
+++ ircd-pi1.0a/src/dline_conf.c	Fri May 10 23:49:04 2002
@@ -1,7 +1,7 @@
 /*
  * dline_conf.c
  *
- * $Id: dline_conf.c,v 1.36 1999/12/11 04:11:34 lusky Exp $
+ * $Id: dline_conf.c,v 1.2 2002/05/11 03:49:04 smoli Exp $
  */
 #include "dline_conf.h"
 #include "class.h"
@@ -504,7 +504,7 @@
       /* #endif */
 
       /* if this is a *@ Kline, then we can toast all the other Klines in the clist */
-      if (!(strcmp(conf_ptr->user,"*")))
+      if (!(irccmp(conf_ptr->user,"*")))
         clist=trim_ip_Klines(clist,0);
 
       conf_ptr->next=clist;
@@ -521,7 +521,7 @@
   for (scan=node->conf;scan;scan=scan->next)
     {
       if (((scan->status & CONF_KILL) || (scan->flags & CONF_FLAGS_E_LINED)) &&
-          (!(strcmp(scan->user,"*"))) &&
+          (!(irccmp(scan->user,"*"))) &&
           (scan->ip_mask<host_mask)) break;
     }
   if (scan) return; /* don't bother adding */
@@ -529,7 +529,7 @@
   /* update oracle */
   ike_oracle[host_ip>>24] |= ((0xffffffff-host_mask)+host_ip);
 
-  if (strcmp(conf_ptr->user,"*")) 
+  if (irccmp(conf_ptr->user,"*")) 
     {  /* not adding a *@ Kline, just slap it in */
       conf_ptr->next=node->conf;
       node->conf=conf_ptr;
@@ -577,7 +577,7 @@
         delete_ip_subtree(ip_Kline[host_ip>>24], host_ip, host_mask, &clist);
 
       /* if this is a *@ Eline, then we can toast all the others in the clist */
-      if (!(strcmp(conf_ptr->user,"*"))) 
+      if (!(irccmp(conf_ptr->user,"*"))) 
         clist=trim_ip_Elines(clist,0);
 
       conf_ptr->next=clist;
@@ -594,7 +594,7 @@
   for (scan=node->conf;scan;scan=scan->next)
     {
       if ((scan->flags & CONF_FLAGS_E_LINED) &&
-          (!(strcmp(scan->user,"*"))) &&
+          (!(irccmp(scan->user,"*"))) &&
           (scan->ip_mask<host_mask)) break;
     }
   if (scan) return; /* don't bother adding */
@@ -602,7 +602,7 @@
   /* update oracle */
   ike_oracle[host_ip>>24] |= ((0xffffffff-host_mask)+host_ip);
 
-  if (strcmp(conf_ptr->user,"*")) 
+  if (irccmp(conf_ptr->user,"*")) 
     {  /* not adding a *@ Eline, just slap it in */
       conf_ptr->next=node->conf;
       node->conf=conf_ptr;
diff -uNrd ircd-hybrid-6.0/src/fdlist.c ircd-pi1.0a/src/fdlist.c
--- ircd-hybrid-6.0/src/fdlist.c	Sat Jul 24 03:58:57 1999
+++ ircd-pi1.0a/src/fdlist.c	Fri Nov  2 19:23:28 2001
@@ -3,7 +3,7 @@
  * fdlist.c   maintain lists of certain important fds 
  *
  *
- * $Id: fdlist.c,v 1.10 1999/07/24 07:58:57 tomh Exp $
+ * $Id: fdlist.c,v 1.1.1.1 2001/11/03 00:23:28 shifty Exp $
  */
 #include "fdlist.h"
 #include "client.h"  /* struct Client */
diff -uNrd ircd-hybrid-6.0/src/fileio.c ircd-pi1.0a/src/fileio.c
--- ircd-hybrid-6.0/src/fileio.c	Thu Oct  5 23:00:58 2000
+++ ircd-pi1.0a/src/fileio.c	Fri May 10 23:49:04 2002
@@ -4,7 +4,7 @@
  * Copyright (C) 1990 Jarkko Oikarinen and
  *                    University of Oulu, Co Center
  *
- * $Id: fileio.c,v 1.5 2000/10/06 03:00:58 lusky Exp $
+ * $Id: fileio.c,v 1.5 2002/05/11 03:49:04 smoli Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -21,11 +21,13 @@
  * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */
 #include "fileio.h"
+#include "irc_string.h"
 #include <stdio.h>  /* BUFSIZ, EOF */
 #include <stdlib.h> /* malloc, free */
 #include <fcntl.h>  /* O_RDONLY, O_WRONLY, ... */
 #include <unistd.h> /* read, write, open, close */
 #include <assert.h> /* assert */
+#include <string.h>
 
 #define FB_EOF  0x01
 #define FB_FAIL 0x02
@@ -171,7 +173,7 @@
   assert(fb);
 
   if (0 == fb->flags) {
-    n = write(fb->fd, str, strlen(str));
+    n = write(fb->fd, str, irclen(str));
     if (-1 == n)
       fb->flags |= FB_FAIL;
   }
diff -uNrd ircd-hybrid-6.0/src/flud.c ircd-pi1.0a/src/flud.c
--- ircd-hybrid-6.0/src/flud.c	Sat Nov 18 14:11:11 2000
+++ ircd-pi1.0a/src/flud.c	Fri Nov  2 19:23:29 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: flud.c,v 1.5 2000/11/18 19:11:11 lusky Exp $
+ *   $Id: flud.c,v 1.1.1.1 2001/11/03 00:23:29 shifty Exp $
  */
 #include "flud.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/hash.c ircd-pi1.0a/src/hash.c
--- ircd-hybrid-6.0/src/hash.c	Mon Jan 31 19:44:11 2000
+++ ircd-pi1.0a/src/hash.c	Fri May 10 23:49:04 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: hash.c,v 1.37 2000/02/01 00:44:11 lusky Exp $
+ *  $Id: hash.c,v 1.2 2002/05/11 03:49:04 smoli Exp $
  */
 #include "s_conf.h"
 #include "channel.h"
@@ -539,7 +539,7 @@
             {
               sprintf(result_buf,"Hash Entry:%6d Hits;%7d Links:%6d\n",
                             i, tab->hits, l);
-              write(out,result_buf,strlen(result_buf));
+              write(out,result_buf,irclen(result_buf));
             }
         }
 
diff -uNrd ircd-hybrid-6.0/src/i386/asmtest.c ircd-pi1.0a/src/i386/asmtest.c
--- ircd-hybrid-6.0/src/i386/asmtest.c	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/src/i386/asmtest.c	Fri May 10 23:49:07 2002
@@ -0,0 +1,81 @@
+#include <stdio.h>
+#include <string.h>
+#include <sys/time.h>
+
+#include "irc_string.h"
+
+struct timezone tz = { 0, 0 };
+unsigned long stamp = 0;
+struct timeval tv;
+
+void profile_start()
+{
+  gettimeofday(&tv, &tz);
+  stamp = tv.tv_usec + tv.tv_sec * 1000000;
+}
+
+void profile_end(const char *function, const void *buf, unsigned long size, unsigned long bytes)
+{
+  unsigned long current;
+  unsigned long delta;
+  
+  gettimeofday(&tv, &tz);
+  current = tv.tv_usec + tv.tv_sec * 1000000;
+  delta = current - stamp;
+  
+  fprintf(stderr, "function: %s buf: %p size: %lu retval: %lu time: %lu usecs\n",
+          function, buf, size, bytes, delta);
+}
+
+int main()
+{
+  FILE *f;
+  char buf[131072];
+  char buf2[131072];
+  int l1, l2;
+  
+  f = fopen("/etc/services", "r");
+  
+  l1 = fread(buf, 100000, 1, f);
+  rewind(f);
+  fread(buf2, 100000, 1, f);
+  
+  profile_start();
+  l2 = irclen(&buf[1]);
+  profile_end("irclen()", buf, l1, l2);
+
+  usleep(20000);
+  
+  profile_start();
+  l2 = strlen(&buf[1]);
+  profile_end("strlen()", buf, l1, l2);
+
+  usleep(20000);
+
+  profile_start();
+  l2 = irccmp(&buf[1], &buf2[1]);
+  profile_end("irccmp()", buf2, l1, l2);
+
+  usleep(20000);
+
+  profile_start();
+  l2 = strcmp(&buf[1], &buf2[1]);
+  profile_end("strcmp()", buf2, l1, l2);
+
+  usleep(20000);
+
+  profile_start();
+  l2 = ircncmp(&buf[1], &buf2[1], 1000000);
+  profile_end("ircncmp()", buf2, l1, l2);
+
+  usleep(20000);
+
+  profile_start();
+  l2 = strncmp(&buf[1], &buf2[1], 1000000);
+  profile_end("strncmp()", buf2, l1, l2);
+
+  usleep(20000);
+
+  printf("%d %d\n", !irccmp("TESTLINE", ""), !strcmp("TESTLINE", ""));
+  return 0;
+}
diff -uNrd ircd-hybrid-6.0/src/i386/irccmp.asm ircd-pi1.0a/src/i386/irccmp.asm
--- ircd-hybrid-6.0/src/i386/irccmp.asm	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/src/i386/irccmp.asm	Fri May 10 21:30:43 2002
@@ -0,0 +1,182 @@
+; IRC - Internet Relay Chat, src/i386/irccmp.asm
+; Copyright (C) 1990 Jarkko Oikarinen and
+;                    University of Oulu, Computing Center
+;
+; See file AUTHORS in IRC package for additional names of
+; the programmers.
+;
+; This program is free software; you can redistribute it and/or modify
+; it under the terms of the GNU General Public License as published by
+; the Free Software Foundation; either version 1, or (at your option)
+; any later version.
+;
+; This program is distributed in the hope that it will be useful,
+; but WITHOUT ANY WARRANTY; without even the implied warranty of
+; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+; GNU General Public License for more details.
+;
+; You should have received a copy of the GNU General Public License
+; along with this program; if not, write to the Free Software
+; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+;
+; $Id: irccmp.asm,v 1.2 2002/05/11 01:30:43 smoli Exp $
+
+		global	irccmp
+
+[segment .text]
+
+irccmp:		push	ebx
+		push	edi
+		push	esi
+		push	ecx
+                xor     eax, eax
+		mov	esi, [esp + 14h]
+		mov	edi, [esp + 18h]
+		cmp	esi, edi
+		jne	.loop
+		pop	ecx
+		pop	esi
+		pop	edi
+		pop	ebx
+		ret
+
+.loop:		mov	ebx, [esi]
+		mov	ecx, [edi]
+
+		test	bl, bl		; byte 0
+		jz	.exit_cl
+		test	cl, cl
+		jz	.exit_bl
+
+		cmp	bl, 'a'
+		jb	.b0_nc
+		cmp	bl, 'z'
+		ja	.b0_ch
+		sub	bl, 20h
+.b0_ch:		cmp	bl, 'à'
+		jb	.b0_nc
+		cmp	bl, 'ÿ'
+		jae	.b0_nc
+		sub	bl, 20h
+.b0_nc:		cmp	cl, 'a'
+		jb	.c0_nc
+		cmp	cl, 'z'
+		ja	.c0_ch
+		sub	cl, 20h
+.c0_ch:		cmp	cl, 'à'
+		jb	.c0_nc
+		cmp	cl, 'ÿ'
+		jae	.c0_nc
+		sub	cl, 20h
+.c0_nc:
+		cmp	bl, cl
+		jne	.exit_bl
+
+		test	bh, bh		; byte 1
+		jz	.exit_ch
+		test	ch, ch
+		jz	.exit_bh
+		
+		cmp	bh, 'a'
+		jb	.b1_nc
+		cmp	bh, 'z'
+		ja	.b1_ch
+		sub	bh, 20h
+.b1_ch:		cmp	bh, 'à'
+		jb	.b1_nc
+		cmp	bh, 'ÿ'
+		jae	.b1_nc
+		sub	bh, 20h
+.b1_nc:		cmp	ch, 'a'
+		jb	.c1_nc
+		cmp	ch, 'z'
+		ja	.c1_ch
+		sub	ch, 20h
+.c1_ch:		cmp	ch, 'à'
+		jb	.c1_nc
+		cmp	ch, 'ÿ'
+		jae	.c1_nc
+		sub	ch, 20h
+.c1_nc:
+		cmp	bh, ch
+		je	.rotate
+
+.exit_cl:	movzx	eax, cl
+		xor	ecx, ecx
+		jz	.exit
+.exit_bl:	movzx	eax, bl
+		jmp	.exit
+.exit_bh:	movzx	eax, bh
+		jmp	.exit
+.exit_ch:	movzx	eax, ch
+.exit:
+		pop	ecx
+		pop	esi
+		pop	edi
+		pop	ebx
+		ret
+
+.rotate:	ror	ebx, 10h
+		ror	ecx, 10h
+
+		test	bl, bl		; byte 2
+		jz	.exit_cl
+		test	cl, cl
+		jz	.exit_bl
+
+		cmp	bl, 'a'
+		jb	.b2_nc
+		cmp	bl, 'z'
+		ja	.b2_ch
+		sub	bl, 20h
+.b2_ch:		cmp	bl, 'à'
+		jb	.b2_nc
+		cmp	bl, 'ÿ'
+		jae	.b2_nc
+		sub	bl, 20h
+.b2_nc:		cmp	cl, 'a'
+		jb	.c2_nc
+		cmp	cl, 'z'
+		ja	.c2_ch
+		sub	cl, 20h
+.c2_ch:		cmp	cl, 'à'
+		jb	.c2_nc
+		cmp	cl, 'ÿ'
+		jae	.c2_nc
+		sub	cl, 20h
+.c2_nc:
+		cmp	bl, cl
+		jne	.exit_bl
+
+		test	bh, bh		; byte 3
+		jz	.exit_ch
+		test	ch, ch
+		jz	.exit_bh
+		
+		cmp	bh, 'a'
+		jb	.b3_nc
+		cmp	bh, 'z'
+		ja	.b3_ch
+		sub	bh, 20h
+.b3_ch:		cmp	bh, 'à'
+		jb	.b3_nc
+		cmp	bh, 'ÿ'
+		jae	.b3_nc
+		sub	bh, 20h
+.b3_nc:		cmp	ch, 'a'
+		jb	.c3_nc
+		cmp	ch, 'z'
+		ja	.c3_ch
+		sub	ch, 20h
+.c3_ch:		cmp	ch, 'à'
+		jb	.c3_nc
+		cmp	ch, 'ÿ'
+		jae	.c3_nc
+		sub	ch, 20h
+.c3_nc:
+		cmp	bh, ch
+		jne	.exit_bh
+
+		add	esi, 04h
+		add	edi, 04h
+		jmp	.loop
diff -uNrd ircd-hybrid-6.0/src/i386/irclen.asm ircd-pi1.0a/src/i386/irclen.asm
--- ircd-hybrid-6.0/src/i386/irclen.asm	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/src/i386/irclen.asm	Fri May 10 23:49:07 2002
@@ -0,0 +1,67 @@
+; IRC - Internet Relay Chat, src/s_serv.c
+; Copyright (C) 1990 Jarkko Oikarinen and
+;                    University of Oulu, Computing Center
+;
+; See file AUTHORS in IRC package for additional names of
+; the programmers.
+;
+; This program is free software; you can redistribute it and/or modify
+; it under the terms of the GNU General Public License as published by
+; the Free Software Foundation; either version 1, or (at your option)
+; any later version.
+;
+; This program is distributed in the hope that it will be useful,
+; but WITHOUT ANY WARRANTY; without even the implied warranty of
+; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+; GNU General Public License for more details.
+;
+; You should have received a copy of the GNU General Public License
+; along with this program; if not, write to the Free Software
+; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+;
+; $Id: irclen.asm,v 1.2 2002/05/11 03:49:07 smoli Exp $
+;
+; speed gain was 50%, compared to noarch on i686-pc-linux-gnu, athlon CPU
+;
+		global	irclen
+
+[segment .text]
+
+irclen:		push	esi
+		push	ecx
+
+		xor	ecx, ecx
+		mov	esi, [esp + 0Ch]
+		test	esi, 00000003h
+		jz	.loop
+		
+.align:		test	byte [esi], 0xff
+		jz	.exit
+		inc	esi
+		inc	ecx
+		test	esi, 00000003h
+		jnz	.align
+
+.loop:		lodsd
+		test	al, al
+		jz	.exit
+		inc	ecx
+		test	ah, ah
+		jz	.exit
+		inc	ecx
+
+		ror	eax, 10h
+
+		test	al, al
+		jz	.exit
+		inc	ecx
+		test	ah, ah
+		jz	.exit
+		inc	ecx
+
+		jmp	.loop
+
+.exit:		pop	eax
+		xchg	eax, ecx
+                pop	esi
+                ret
diff -uNrd ircd-hybrid-6.0/src/i386/ircncmp.asm ircd-pi1.0a/src/i386/ircncmp.asm
--- ircd-hybrid-6.0/src/i386/ircncmp.asm	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/src/i386/ircncmp.asm	Fri May 10 23:49:07 2002
@@ -0,0 +1,197 @@
+; IRC - Internet Relay Chat, src/i386/ircncmp.asm
+; Copyright (C) 1990 Jarkko Oikarinen and
+;                    University of Oulu, Computing Center
+;
+; See file AUTHORS in IRC package for additional names of
+; the programmers.
+;
+; This program is free software; you can redistribute it and/or modify
+; it under the terms of the GNU General Public License as published by
+; the Free Software Foundation; either version 1, or (at your option)
+; any later version.
+;
+; This program is distributed in the hope that it will be useful,
+; but WITHOUT ANY WARRANTY; without even the implied warranty of
+; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+; GNU General Public License for more details.
+;
+; You should have received a copy of the GNU General Public License
+; along with this program; if not, write to the Free Software
+; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+;
+; $Id: ircncmp.asm,v 1.3 2002/05/11 03:49:07 smoli Exp $
+
+		global	ircncmp
+
+[segment .text]
+
+ircncmp:	push	ebx
+		push	edi
+		push	esi
+		push	ecx
+		mov	esi, [esp + 14h]
+		mov	edi, [esp + 18h]
+		mov	eax, [esp + 1Ch]
+		test	eax, eax
+		jz	.exit_zero
+		cmp	esi, edi
+		jne	.loop
+		xor	eax, eax
+.exit_zero:	pop	ecx
+		pop	esi
+		pop	edi
+		pop	ebx
+		ret
+
+.loop:		mov	ebx, [esi]
+		mov	ecx, [edi]
+
+		test	bl, bl		; byte 0
+		jz	.exit_cl
+		test	cl, cl
+		jz	.exit_bl
+
+		cmp	bl, 'a'
+		jb	.b0_nc
+		cmp	bl, 'z'
+		ja	.b0_ch
+		sub	bl, 20h
+.b0_ch:		cmp	bl, 'à'
+		jb	.b0_nc
+		cmp	bl, 'ÿ'
+		jae	.b0_nc
+		sub	bl, 20h
+.b0_nc:		cmp	cl, 'a'
+		jb	.c0_nc
+		cmp	cl, 'z'
+		ja	.c0_ch
+		sub	cl, 20h
+.c0_ch:		cmp	cl, 'à'
+		jb	.c0_nc
+		cmp	cl, 'ÿ'
+		jae	.c0_nc
+		sub	cl, 20h
+.c0_nc:
+		cmp	bl, cl
+		jne	.exit_bl
+
+		dec	eax
+		jnz	.continue
+		jz	.exit
+
+.exit_cl:	movzx	eax, cl
+		jmp	.exit
+.exit_bl:	movzx	eax, bl
+.exit:		pop	ecx
+		pop	esi
+		pop	edi
+		pop	ebx
+		ret
+
+.continue:	test	bh, bh		; byte 1
+		jz	.exit_ch
+		test	ch, ch
+		jz	.exit_bh
+		
+		cmp	bh, 'a'
+		jb	.b1_nc
+		cmp	bh, 'z'
+		ja	.b1_ch
+		sub	bh, 20h
+.b1_ch:		cmp	bh, 'à'
+		jb	.b1_nc
+		cmp	bh, 'ÿ'
+		jae	.b1_nc
+		sub	bh, 20h
+.b1_nc:		cmp	ch, 'a'
+		jb	.c1_nc
+		cmp	ch, 'z'
+		ja	.c1_ch
+		sub	ch, 20h
+.c1_ch:		cmp	ch, 'à'
+		jb	.c1_nc
+		cmp	ch, 'ÿ'
+		jae	.c1_nc
+		sub	ch, 20h
+.c1_nc:
+		cmp	bh, ch
+		je	.rotate
+
+.exit_bh:	movzx	eax, bh
+		jmp	.exit
+.exit_ch:	movzx	eax, ch
+		jmp	.exit
+
+.rotate:	dec	eax
+		jz	.exit
+
+		ror	ebx, 10h
+		ror	ecx, 10h
+
+		test	bl, bl		; byte 2
+		jz	.exit_cl
+		test	cl, cl
+		jz	.exit_bl
+
+		cmp	bl, 'a'
+		jb	.b2_nc
+		cmp	bl, 'z'
+		ja	.b2_ch
+		sub	bl, 20h
+.b2_ch:		cmp	bl, 'à'
+		jb	.b2_nc
+		cmp	bl, 'ÿ'
+		jae	.b2_nc
+		sub	bl, 20h
+.b2_nc:		cmp	cl, 'a'
+		jb	.c2_nc
+		cmp	cl, 'z'
+		ja	.c2_ch
+		sub	cl, 20h
+.c2_ch:		cmp	cl, 'à'
+		jb	.c2_nc
+		cmp	cl, 'ÿ'
+		jae	.c2_nc
+		sub	cl, 20h
+.c2_nc:
+		cmp	bl, cl
+		jne	.exit_bl
+
+		dec	eax
+		jz	.exit
+
+		test	bh, bh		; byte 3
+		jz	.exit_ch
+		test	ch, ch
+		jz	.exit_bh
+		
+		cmp	bh, 'a'
+		jb	.b3_nc
+		cmp	bh, 'z'
+		ja	.b3_ch
+		sub	bh, 20h
+.b3_ch:		cmp	bh, 'à'
+		jb	.b3_nc
+		cmp	bh, 'ÿ'
+		jae	.b3_nc
+		sub	bh, 20h
+.b3_nc:		cmp	ch, 'a'
+		jb	.c3_nc
+		cmp	ch, 'z'
+		ja	.c3_ch
+		sub	ch, 20h
+.c3_ch:		cmp	ch, 'à'
+		jb	.c3_nc
+		cmp	ch, 'ÿ'
+		jae	.c3_nc
+		sub	ch, 20h
+.c3_nc:
+		cmp	bh, ch
+		jne	.exit_bh
+
+		dec	eax
+		jz	.exit
+
+		add	esi, 04h
+		add	edi, 04h
+		jmp	.loop
diff -uNrd ircd-hybrid-6.0/src/irc_string.c ircd-pi1.0a/src/irc_string.c
--- ircd-hybrid-6.0/src/irc_string.c	Wed Aug  9 18:50:25 2000
+++ ircd-pi1.0a/src/irc_string.c	Fri Nov  2 19:23:29 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: irc_string.c,v 1.9 2000/08/09 22:50:25 lusky Exp $
+ *  $Id: irc_string.c,v 1.1.1.1 2001/11/03 00:23:29 shifty Exp $
  */
 #include "irc_string.h"
 #include "list.h"
diff -uNrd ircd-hybrid-6.0/src/ircd.c ircd-pi1.0a/src/ircd.c
--- ircd-hybrid-6.0/src/ircd.c	Sat Dec 30 19:12:00 2000
+++ ircd-pi1.0a/src/ircd.c	Tue May 21 22:14:29 2002
@@ -17,16 +17,21 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: ircd.c,v 1.137 2000/12/31 00:12:00 lusky Exp $
+ * $Id: ircd.c,v 1.10 2002/05/22 02:14:29 smoli Exp $
  */
 #include "ircd.h"
 #include "channel.h"
 #include "class.h"
 #include "client.h"
 #include "common.h"
+#ifdef HAVE_SSL
+#include "ssl.h"
+#endif
+#include "config.h"
 #include "dline_conf.h"
 #include "fdlist.h"
 #include "hash.h"
+#include "listener.h"
 #include "irc_string.h"
 #include "ircd_signal.h"
 #include "list.h"
@@ -55,14 +60,18 @@
 #include <stdlib.h>
 #include <string.h>
 #include <stdio.h>
+#include <stdarg.h>
 #include <errno.h>
 #include <time.h>
 #include <pwd.h>
+#include <grp.h>
 #include <fcntl.h>
 #include <unistd.h>
 #include <sys/file.h>
 #include <sys/stat.h>
 #include <sys/socket.h>
+#include <sys/ioctl.h>
+#include <sys/types.h>
 
 #if defined(HAVE_GETOPT_H)
 #include <getopt.h>
@@ -148,6 +157,12 @@
 int     debuglevel = -1;        /* Server debug level */
 char*   debugmode  = "";        /*  -"-    -"-   -"-  */
 
+#ifdef BACKUP
+int     backup_mode = 0;
+int     main_retry = 0;
+int     backup_retry = 0;
+#endif /* BACKUP */
+
 
 int     rehashed = YES;
 int     dline_in_progress = NO; /* killing off matching D lines ? */
@@ -161,13 +176,20 @@
 /* Changed by Taner Halicioglu (taner@CERF.NET) */
 
 #define LOADCFREQ 5     /* every 5s */
-#define LOADRECV 40     /* 40k/s */
+#define LOADRECV 20     /* 40k/s */
 
 int    LRV = LOADRECV;
 time_t LCF = LOADCFREQ;
 float currlife = 0.0;
 
 
+struct Class* cltmp;
+
+#define INIT_OK   1
+#define INIT_FAIL 0
+
+static int screen_width = 80;
+
 /*
  * get_vm_top - get the operating systems notion of the resident set size
  */
@@ -196,17 +218,62 @@
 }
 
 /*
+ * get terminal screen width
+ */
+int get_screenwidth()
+{
+  struct winsize size;
+
+  if(ioctl(STDOUT_FILENO, TIOCGWINSZ, &size) < 0)
+    return 0;
+
+  return size.ws_col;
+}
+
+void msg_init(char *format, ...)
+{
+  va_list args;
+  char buffer1[512];
+  char buffer2[512];
+  
+  va_start(args, format);
+  vsprintf(buffer1, format, args);
+  sprintf(buffer2, "%-511s", buffer1);
+  
+  if(screen_width > 10)
+    buffer2[screen_width - 10] = '\0';
+  else
+    buffer2[0] = '\0';
+  
+  fprintf(stderr, "%s", buffer2);
+  fflush(stderr);
+  
+  va_end(args);  
+}
+
+void msg_init_stat(int status)
+{
+  if(status)
+    fprintf(stderr, "  (\033[1;34mok\033[0;37m)\n");
+  else
+    {
+      fprintf(stderr, "(\033[1;31mfailed\033[0;37m)\nconsult " DPATH LPATH " for details\n");
+      exit(-1);
+    }
+}
+
+
+/*
  * init_sys
  */
-static void init_sys(int boot_daemon)
+static void init_sys()
 {
 #ifdef RLIMIT_FD_MAX
   struct rlimit limit;
 
-  if (!getrlimit(RLIMIT_FD_MAX, &limit))
+  if(!getrlimit(RLIMIT_FD_MAX, &limit))
     {
-
-      if (limit.rlim_max < MAXCONNECTIONS)
+      if(limit.rlim_max < MAXCONNECTIONS)
         {
           fprintf(stderr,"ircd fd table too big\n");
           fprintf(stderr,"Hard Limit: %ld IRC max: %d\n",
@@ -238,31 +305,36 @@
       printf("Value of NOFILE is %d\n", NOFILE);
     }
 #endif        /* RLIMIT_FD_MAX */
+}
 
-  /* This is needed to not fork if -s is on */
-  if (boot_daemon)
+static void init_daemon()
+{
+  int pid;
+  
+  msg_init("detaching");
+  
+  if((pid = fork()) < 0)
     {
-      int pid;
-      if((pid = fork()) < 0)
+      msg_init_stat(INIT_FAIL);
+      exit(0);
+    }
+  else if(pid > 0)
+    {
+      fprintf(stderr, " (\033[1;32m%u\033[0m)\n", pid);
+      exit(0);
+    }
+#ifdef TIOCNOTTY
+    { /* scope */
+      int fd;
+      if((fd = open("/dev/tty", O_RDWR)) >= 0)
         {
-          fprintf(stderr, "Couldn't fork: %s\n", strerror(errno));
-          exit(0);
+          ioctl(fd, TIOCNOTTY, NULL);
+          close(fd);
         }
-      else if (pid > 0)
-        exit(0);
-#ifdef TIOCNOTTY
-      { /* scope */
-        int fd;
-        if ((fd = open("/dev/tty", O_RDWR)) >= 0)
-          {
-            ioctl(fd, TIOCNOTTY, NULL);
-            close(fd);
-          }
-      }
-#endif
-     setsid();
     }
-  close_all_connections();
+#endif
+  setsid();
+/*  close_all_connections(); damn, ommiting this could be dangerous */
 }
 
 /*
@@ -327,11 +399,7 @@
       break;
     case 'v':
       printf("ircd %s\n\tzlib %s\n\tircd_dir: %s\n", version,
-#ifndef ZIP_LINKS
-             "not used",
-#else
-              zlib_version,
-#endif
+              ZLIB_VERSION,
               ConfigFileEntry.dpath);
       exit(0);
       break;   /* NOT REACHED */
@@ -628,7 +696,7 @@
   if ((fd = open(PPATH, O_CREAT|O_WRONLY, 0600))>=0)
     {
       ircsprintf(buff,"%d\n", (int)getpid());
-      if (write(fd, buff, strlen(buff)) == -1)
+      if (write(fd, buff, irclen(buff)) == -1)
         log(L_ERROR,"Error writing to pid file %s", PPATH);
       close(fd);
       return;
@@ -640,19 +708,53 @@
 
 int main(int argc, char *argv[])
 {
-  uid_t       uid;
-  uid_t       euid;
-  time_t      delay = 0;
-  aConfItem*  aconf;
+  uid_t            cuid, uid;
+  gid_t            gid;
+  time_t           delay = 0;
+  aConfItem       *aconf;
+  struct passwd   *pwd;
+  struct group    *grp;
 
+  cuid = getuid();
+  
+  if(!(pwd = getpwnam(IRCDUSER)))
+    {
+      fprintf(stderr, "ERROR: Invalid user " IRCDUSER);
+      exit(errno);
+    }
+  grp = getgrgid(pwd->pw_gid);
+  uid = pwd->pw_uid;
+  gid = grp->gr_gid;
+  
+  screen_width = get_screenwidth();
+  
   /*
    * save server boot time right away, so getrusage works correctly
    */
-  if ((CurrentTime = time(0)) == -1)
+  if((CurrentTime = time(NULL)) == -1)
     {
       fprintf(stderr, "ERROR: Clock Failure: %s\n", strerror(errno));
       exit(errno);
     }
+
+  msg_init("entering server root");
+  if(chdir(DPATH))
+    {
+      msg_init_stat(INIT_FAIL);
+      exit(-1);
+    }
+  msg_init_stat(INIT_OK);
+
+  /* seed the random generator */
+  msg_init("seeding random number generator");
+  srand((int)CurrentTime);
+#ifdef HAVE_SSL
+  if(!ssl_seed_prng(RNPATH))
+    msg_init_stat(INIT_FAIL);
+  else
+#endif
+    msg_init_stat(INIT_OK);
+
   /* 
    * set initialVMTop before we allocate any memory
    */
@@ -678,14 +780,10 @@
  * criteria do not match the requirements of ircd 
  */
 #ifdef SETUID_ROOT
-  if (setuid(IRCD_UID) < 0)
+  if (setuid(0) < 0)
     exit(-1); /* blah.. this should be done better */
 #endif
 
-
-  uid = getuid();
-  euid = geteuid();
-
   ConfigFileEntry.dpath = DPATH;
 
   ConfigFileEntry.configfile = CPATH;   /* Server configuration file */
@@ -706,20 +804,6 @@
   ConfigFileEntry.glinefile = GLINEFILE;
 #endif
 
-#ifdef  CHROOTDIR
-  if (chdir(DPATH))
-    {
-      perror("chdir " DPATH );
-      exit(-1);
-    }
-
-  if (chroot(DPATH))
-    {
-      fprintf(stderr,"ERROR:  Cannot chdir/chroot\n");
-      exit(5);
-    }
-#endif /*CHROOTDIR*/
-
 #ifdef  ZIP_LINKS
   if (zlib_version[0] == '0')
     {
@@ -731,7 +815,7 @@
       fprintf(stderr, "incompatible zlib version\n");
       exit(1);
     }
-  if (strcmp(zlib_version, ZLIB_VERSION) != 0)
+  if (irccmp(zlib_version, ZLIB_VERSION) != 0)
     {
       fprintf(stderr, "warning: different zlib version\n");
     }
@@ -740,69 +824,16 @@
   myargv = argv;
   umask(077);                /* better safe than sorry --SRB */
 
-  setuid(uid);
   parse_command_line(argc, argv); 
 
-#ifndef CHROOT
-  if (chdir(ConfigFileEntry.dpath))
-    {
-      perror("chdir");
-      exit(-1);
-    }
-#endif
-
-#if !defined(IRC_UID)
-  if ((uid != euid) && !euid)
-    {
-      fprintf(stderr,
-              "ERROR: do not run ircd setuid root. " \
-              "Make it setuid a normal user.\n");
-      exit(-1);
-    }
-#endif
-
-#if !defined(CHROOTDIR) || (defined(IRC_UID) && defined(IRC_GID))
-
-  setuid(euid);
-
-  if (getuid() == 0)
-    {
-# if defined(IRC_UID) && defined(IRC_GID)
-
-      /* run as a specified user */
-      fprintf(stderr,"WARNING: running ircd with uid = %d\n", IRC_UID);
-      fprintf(stderr,"         changing to gid %d.\n",IRC_GID);
-
-      /* setgid/setuid previous usage noted unsafe by ficus@neptho.net
-       */
-
-      if (setgid(IRC_GID) < 0)
-        {
-          fprintf(stderr,"ERROR: can't setgid(%d)\n", IRC_GID);
-          exit(-1);
-        }
-
-      if(setuid(IRC_UID) < 0)
-        {
-          fprintf(stderr,"ERROR: can't setuid(%d)\n", IRC_UID);
-          exit(-1);
-        }
-
-#else
-      /* check for setuid root as usual */
-      fprintf(stderr,
-              "ERROR: do not run ircd setuid root. " \
-              "Make it setuid a normal user.\n");
-      return -1;
-# endif 
-            } 
-#endif /*CHROOTDIR/UID/GID*/
-
+  msg_init("initializing ircd subsystem");
   setup_signals();
 
-  init_sys(bootDaemon);
+  init_sys();
   init_log(logFileName);
+  msg_init_stat(INIT_OK);
 
+  msg_init("initializing internal structures");
   initialize_message_files();
 
   dbuf_init();  /* set up some dbuf stuff to control paging */
@@ -819,8 +850,52 @@
 
   fdlist_init();
   init_netio();
+  msg_init_stat(INIT_OK);
 
-  read_conf_files(YES);         /* cold start init conf files */
+  msg_init("reading config file");
+  if(read_conf_files(YES))      /* cold start init conf files */
+    {
+      log(L_ERROR, "starting under uid %u, but maybe listeners "
+                   "below 1024 or port already bound", uid);
+      msg_init_stat(INIT_FAIL);
+    }
+  else
+    msg_init_stat(INIT_OK);
+
+#ifdef HAVE_SSL
+  msg_init("initializing secure socket layer");
+  if(!(ssl_capable = !ssl_init()))
+    msg_init_stat(INIT_FAIL);
+  else
+    msg_init_stat(INIT_OK);
+#endif
+
+#ifdef CHROOTDIR
+  msg_init("entering chroot environment");
+  if(chroot(DPATH))
+    {
+      log(L_ERROR, "Could not chroot: %s", strerror(errno));
+      msg_init_stat(INIT_FAIL);
+    }
+  msg_init_stat(INIT_OK);
+#endif /* CHROOTDIR */
+  
+  if(cuid == 0)
+    {
+      msg_init("setuid/setgid to %s/%s", pwd->pw_name, grp->gr_name);
+      if(setgid(gid) < 0 || setuid(uid) < 0)
+        {          
+          msg_init_stat(INIT_FAIL);
+          return -1;
+        }      
+      else
+        msg_init_stat(INIT_OK);
+    }
+  else if(cuid != uid)
+    log(L_WARN, "Current UID %u inappropriate", cuid);
+  
+  if(bootDaemon)
+    init_daemon();  
 
   aconf = find_me();
   if (EmptyString(me.name))
@@ -836,6 +911,11 @@
   me.lasttime = me.since = me.firsttime = CurrentTime;
   add_to_client_hash_table(me.name, &me);
 
+#ifdef HAVE_SSL
+  SetSSL(&me);
+  SetSSLServ(&me);
+#endif  
+  
   check_class();
   write_pidfile();
 
diff -uNrd ircd-hybrid-6.0/src/ircd_signal.c ircd-pi1.0a/src/ircd_signal.c
--- ircd-hybrid-6.0/src/ircd_signal.c	Sat Jul 31 04:22:58 1999
+++ ircd-pi1.0a/src/ircd_signal.c	Tue May 21 22:14:29 2002
@@ -17,14 +17,16 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: ircd_signal.c,v 1.2 1999/07/31 08:22:58 tomh Exp $
+ * $Id: ircd_signal.c,v 1.5 2002/05/22 02:14:29 smoli Exp $
  */
+#include "config.h"
 #include "ircd_signal.h"
 #include "ircd.h"         /* dorehash */
 #include "restart.h"      /* server_reboot */
 #include "s_log.h"
 #include "send.h"         /* flush_connections */
 
+#include <stdlib.h>
 #include <signal.h>
 
 /*
@@ -95,7 +97,11 @@
   sigaddset(&act.sa_mask, SIGHUP);
   sigaction(SIGHUP, &act, 0);
 
+#ifdef CHROOTDIR
+  act.sa_handler = sigterm_handler;
+#else
   act.sa_handler = sigint_handler;
+#endif
   sigaddset(&act.sa_mask, SIGINT);
   sigaction(SIGINT, &act, 0);
 
diff -uNrd ircd-hybrid-6.0/src/list.c ircd-pi1.0a/src/list.c
--- ircd-hybrid-6.0/src/list.c	Sat Nov 18 14:11:11 2000
+++ ircd-pi1.0a/src/list.c	Fri Nov  2 19:23:30 2001
@@ -19,7 +19,7 @@
  *
  *  (C) 1988 University of Oulu, Computing Center and Jarkko Oikarinen
  *
- * $Id: list.c,v 1.41 2000/11/18 19:11:11 lusky Exp $
+ * $Id: list.c,v 1.1.1.1 2001/11/03 00:23:30 shifty Exp $
  */
 #include "struct.h"
 #include "blalloc.h"
diff -uNrd ircd-hybrid-6.0/src/listener.c ircd-pi1.0a/src/listener.c
--- ircd-hybrid-6.0/src/listener.c	Sat Oct  9 23:43:01 1999
+++ ircd-pi1.0a/src/listener.c	Tue May 21 22:14:29 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: listener.c,v 1.18 1999/10/10 03:43:01 lusky Exp $
+ *  $Id: listener.c,v 1.5 2002/05/22 02:14:29 smoli Exp $
  */
 #include "listener.h"
 #include "client.h"
@@ -29,6 +29,7 @@
 #include "s_stats.h"
 #include "send.h"
 #include "struct.h"
+#include "config.h"
 
 #include <assert.h>
 #include <string.h>
@@ -57,7 +58,10 @@
   listener->fd          = -1;
   listener->port        = port;
   listener->addr.s_addr = addr.s_addr;
-
+#ifdef HAVE_SSL
+  listener->is_ssl      = 0;
+#endif
+  
 #ifdef NULL_POINTER_NOT_ZERO
   listener->next = NULL;
   listener->conf = NULL;
@@ -218,7 +222,12 @@
  * vhost_ip - if non-null must contain a valid IP address string in
  * the format "255.255.255.255"
  */
-void add_listener(int port, const char* vhost_ip) 
+
+#ifdef HAVE_SSL
+int add_listener(int port, const char* vhost_ip, int is_ssl)
+#else
+int add_listener(int port, const char* vhost_ip)
+#endif
 {
   struct Listener* listener;
   struct in_addr   vaddr;
@@ -227,30 +236,37 @@
    * if no port in conf line, don't bother
    */
   if (0 == port)
-    return;
+    return 0;
 
   vaddr.s_addr = INADDR_ANY;
 
   if (vhost_ip) {
     vaddr.s_addr = inet_addr(vhost_ip);
     if (INADDR_NONE == vaddr.s_addr)
-      return;
+      return 0;
   }
 
   if ((listener = find_listener(port, vaddr))) {
     listener->active = 1;
-    return;
+    return 0;
   }
 
   listener = make_listener(port, vaddr);
 
-  if (inetport(listener)) {
+#ifdef HAVE_SSL
+  listener->is_ssl = is_ssl;
+#endif
+  
+  if(inetport(listener)) {
     listener->active = 1;
     listener->next   = ListenerPollList;
-    ListenerPollList = listener; 
+    ListenerPollList = listener;
+    return 0;
   }
   else
     free_listener(listener);
+  
+  return 1;
 }
 
 void mark_listeners_closing(void)
diff -uNrd ircd-hybrid-6.0/src/m_admin.c ircd-pi1.0a/src/m_admin.c
--- ircd-hybrid-6.0/src/m_admin.c	Fri Nov 10 21:30:23 2000
+++ ircd-pi1.0a/src/m_admin.c	Fri Nov  2 19:23:30 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_admin.c,v 1.2 2000/11/11 02:30:23 lusky Exp $
+ *   $Id: m_admin.c,v 1.1.1.1 2001/11/03 00:23:30 shifty Exp $
  */
 #include "m_commands.h"
 #include "client.h"
